package ac.essex.gp.multiclass;

/**
 * Class which holds data about a particular class's results.
*
* @author Olly Oechsle, University of Essex, Date: 09-Feb-2007
* @version 1.0
*/
public final class ClassResult {

    public String name;

    public int classID;

    public int correct;

    public int total;

    public ClassResult(String name, int classID) {
        this.name = name;
        this.classID = classID;
        this.correct = 0;
        this.total = 0;
    }

    public void registerHit() {
        correct++;
        total++;
    }

    public void registerMiss() {
        total++;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        ClassResult that = (ClassResult) o;

        if (classID != that.classID) return false;

        return true;
    }

    public int hashCode() {
        return classID;
    }
}
