package ac.essex.gp.nodes.imaging;

import ac.essex.gp.params.NodeConstraints;
import ac.essex.gp.params.RangeTypes;
import ac.essex.gp.tree.Terminal;
import ac.essex.gp.problems.DataStack;

/**
* Returns the grey value of the pixel in the image. Coordinates are defined by the DataStack object.
 *
 * @author Olly Oechsle, University of Essex, Date: 06-Jul-2007
 * @version 1.0
 */
public class GreyValue extends Terminal {

    public int[] getReturnTypes() {
        return new int[]{NodeConstraints.NUMBER, NodeConstraints.INTEGER, NodeConstraints.RANGE255, NodeConstraints.FEATURE};
    }

    public double execute(DataStack data) {
        data.usesImaging = true;
        data.value = data.getImage().getGreyValue(data.x, data.y);
        return debugger == null? data.value : debugger.record(data.value);
    }

    public String toJava() {
        return "image.getGreyValue(x, y)";
    }

    public String getShortName() {
        return "Gr";
    }

}