package ac.essex.gp.nodes.imaging.image;

import ac.essex.gp.params.NodeConstraints;
import ac.essex.gp.params.RangeTypes;
import ac.essex.gp.problems.DataStack;
import ac.essex.gp.tree.Terminal;

/**
 * Gets the average lightness of the whole image
 *
 * @author Olly Oechsle, University of Essex, Date: 26-Jun-2007
 * @version 1.0
 */
public class ImageLightnessMean extends Terminal {

    public int[] getReturnTypes() {
        return new int[]{NodeConstraints.NUMBER, NodeConstraints.FLOATING_POINT_NUMBER, NodeConstraints.RANGE255};
    }    
    public double execute(DataStack data) {
        data.value = data.getImage().getLightnessMean();        
        return debugger == null? data.value : debugger.record(data.value);
    }

    public String toJava() {
        return "image.getLightnessMean()";
    }

    public int getDefaultRangeType() {
        return RangeTypes.RANGE_8BIT_INT;
    }

    public String getShortName() {
        return "ILm";
    }

}
