package ac.essex.gp.nodes.imaging.texture;

import ac.essex.gp.problems.DataStack;
import ac.essex.gp.tree.Terminal;
import ac.essex.gp.params.NodeConstraints;
import ac.essex.gp.params.RangeTypes;

/**
* Returns the result of a vertical sobel operation on the image, at its current position.
 *
 * @author Olly Oechsle, University of Essex, Date: 15-Feb-2007
 * @version 1.0
 */
public class VerticalSobel extends Terminal {

    public int[] getReturnTypes() {
        return new int[]{NodeConstraints.NUMBER, NodeConstraints.INTEGER, NodeConstraints.RANGE255, NodeConstraints.FEATURE};
    }

    public double execute(DataStack data) {
        data.usesImaging = true;        
        data.value = data.getImage().getVerticalSobel(data.x, data.y);
        return debugger == null? data.value : debugger.record(data.value);
    }

    public String toJava() {
        return "image.getVerticalSobel(x, y)";
    }

    public String getShortName() {
        return "VS";
    }

}
