package ac.essex.gp.nodes.imaging.texture2;

import ac.essex.gp.tree.Terminal;
import ac.essex.gp.params.NodeConstraints;
import ac.essex.gp.params.RangeTypes;
import ac.essex.gp.problems.DataStack;
import ac.essex.ooechs.imaging.commons.PixelLoader;

/**
 * Gets the number of edges on a vertical line at the current position on the image
 *
 * @author Olly Oechsle, University of Essex, Date: 06-Jul-2007
 * @version 1.0
 */
public class VLine2Edges extends Terminal {

    public int[] getReturnTypes() {
        return new int[]{NodeConstraints.NUMBER, NodeConstraints.INTEGER, NodeConstraints.FEATURE};
    }

    public double execute(DataStack data) {
        data.usesImaging = true;
        PixelLoader image = data.getImage();
        int x = data.getX();
        int y = data.getY();
        data.value = image.getVLine2().getEdgeCount(image, x, y);
        return debugger == null? data.value : debugger.record(data.value);
    }

    public String toJava() {
        return "image.getVLine2().getEdgeCount(image, x, y)";
    }

    public String getShortName() {
        return "v2e";
    }

}
