package ac.essex.gp.tree;

/**
 * A summary of the usage of a node in a tree, contains values such
 * as how many times it was executed and whether it always returns the
 * same value. If it does the tree optimiser may opt to replace the node
 * with an ERC instead.
 *
 * @author Olly Oechsle, University of Essex, Date: 16-Jan-2007
 * @version 1.0
 */
public class DebugResults {

    protected int numberOfExecutions = 0;

    private double value = -1;

    boolean alwaysTheSame = true;

    public DebugResults() {
        numberOfExecutions = 0;
    }

    public double record(double value)  {
        if (this.value != -1 && value != this.value) {
            alwaysTheSame = false;
        }
        numberOfExecutions++;
        this.value = value;
        return value;
    }

    public double getLastValue() {
        return value;
    }

    public boolean alwaysTheSame() {
        return alwaysTheSame;
    }

    public boolean neverExecuted() {
        return numberOfExecutions == 0;
    }

}
