package ac.essex.gp.util;

import ac.essex.gp.params.NodeConstraints;
import ac.essex.gp.params.GPParams;

import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.*;
import java.util.Vector;

/**
 * Allows you to choose which nodes should be used by the Genetic Programming
 * system. Appears as part of the GPStartDialog object.
 *
 * @see GPStartDialog
 * @author Olly Oechsle, University of Essex, Date: 26-Jun-2007
 * @version 1.0
 */
public class NodeSelectionDialogOLD extends JDialog implements ActionListener {

    protected JButton ok, cancel;

    protected Vector<NodeConstraints> nodes;

    protected Vector<JCheckBox> checkboxes;

    public NodeSelectionDialogOLD(JFrame owner, GPParams p) {

        super(owner);

        setTitle("Advanced Node Selection");

        nodes = p.getNodes();

        JPanel panel = new JPanel();

        panel.setLayout(new GridLayout(nodes.size(), 1));

        checkboxes = new Vector<JCheckBox>();

        for (int i = 0; i < nodes.size(); i++) {
            NodeConstraints nodeConstraints = nodes.elementAt(i);
            JCheckBox c = new JCheckBox(nodeConstraints.toString(), nodeConstraints.isEnabled());
            checkboxes.add(c);
            panel.add(c);
        }

        Container c = getContentPane();

        ok = new JButton("OK");
        ok.addActionListener(this);
        cancel = new JButton("Cancel");
        cancel.addActionListener(this);

        JPanel bottom = new JPanel(new FlowLayout(FlowLayout.RIGHT));

        bottom.add(ok);
        bottom.add(cancel);

        c.add(new JScrollPane(panel), BorderLayout.CENTER);
        c.add(bottom, BorderLayout.SOUTH);

        setSize(400, 550);
        setVisible(true);


    }


    public void actionPerformed(ActionEvent e) {

        if (e.getSource() == ok) {

            for (int i = 0; i < nodes.size(); i++) {
                NodeConstraints nodeConstraints = nodes.elementAt(i);
                JCheckBox checkbox = checkboxes.elementAt(i);
                nodeConstraints.setEnabled(checkbox.isSelected());
            }

        }

        dispose();

    }

}
